#include <gtk/gtk.h>
#include "msgbox.h"
#include "common.h"
#include "regs.h"
#include "midi.h"
#include "sflist.h"
#include "main.h"
#include "general_setting.h"


gint dialog_select_sffile(GtkWidget *widget, gpointer data)
{
  char sffile[1000];
  if (file_dialog(sffile, "Select SoundFont file", sflist_getSFFileName())==FALSE) {
    return 0;
  }
  
  if (sflist_load(sffile)==FALSE) {
    return 0;
  }

  char cfg_fn[1000];
  sprintf(cfg_fn, "%s/tmp.cfg", general_get_rc_dir());
  sflist_make_timidity_config_file(sffile, cfg_fn);
  midi_launch_timidity_and_connect(sffile);

  regs_set_soundfont_name(sflist_getSFName());
  regs_set_stop_name_all();
  set_stop_name_list();
  display_combination();
  midi_set_preset();

  general_set_soundfont_name(sflist_getSFName(), sffile);

  return 0;
}

