#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

#define PROC_SEQCLIENT "/proc/asound/seq/clients"
#define MAXNUM 100

typedef struct {
  int client;
  char* client_name;
  int port;
  char* port_name;
} SEQPORT;

class SCANPORT {
  char* gettok(char *orgstr, int order);
public:
  int num;
  SEQPORT data[MAXNUM];
  SCANPORT();
  ~SCANPORT();
};


SCANPORT::SCANPORT()
{
  num = 0;
  FILE *fp = fopen(PROC_SEQCLIENT, "r");
  if (!fp) {
    return ;
  }
  int client=-1, port=0;
  for (;;) {
    char buf[1000], *p;
    char client_name[1000], port_name[1000];
    fgets(buf,1000,fp);
    if (feof(fp)) break;
    if (!strcmp("Client", gettok(buf, 0))) {
      if (!strcmp("info", p=gettok(buf, 1))) {
	continue;
      }
      client = atoi(p);
      if (strcmp("[Kernel]", gettok(buf,4))) {
	client=-1;
	continue;
      }
      strcpy(client_name, gettok(buf,3));
      printf("=================%d\n", client);
      continue;
    }
    if (!strcmp("Port", gettok(buf,0)) && client>=64) {
      SEQPORT tmp;
      p = gettok(buf,4);
      if (strlen(p)!=6) continue;
      if (p[1]!='R') continue;
      tmp.client = client;
      tmp.client_name = strdup(client_name);
      tmp.port = atoi(gettok(buf,1));
      tmp.port_name = strdup(gettok(buf,3));
      data[num++] = tmp;
      printf("%d:%d  %s  %s\n", client,port,client_name,port_name);
    }
  }
  fclose(fp);
}


SCANPORT::~SCANPORT()
{
  for (int i=0; i<num; i++) {
    free(data[i].client_name);
    free(data[i].port_name);
  }
}

char* SCANPORT::gettok(char *orgstr, int order)
{
  static char res[10000];
  char *p = res;
  int flg_dq = 0;

  res[0]=0;

  for (int i=0; i<order; i++) {
    for (; isspace(*orgstr); orgstr++) 
      ;
    if (!*orgstr) return res;
    for (; (!isspace(*orgstr) || flg_dq)  && *orgstr ; orgstr++) {
      if (*orgstr == 0x22) {
	flg_dq = ~flg_dq;
      }
    }
    if (!*orgstr) return res;
  }
  for (; isspace(*orgstr); orgstr++) 
    ;
  if (!*orgstr)  return res;

  flg_dq = 0;
  for (; (!isspace(*orgstr) || flg_dq) && *orgstr; orgstr++) {
    if (*orgstr == 0x22) {
      flg_dq = ~flg_dq;
    }
    *(p++) = *orgstr;
  }
  *p = 0;

  if (p == res) return res;
  return res;
}
